/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180427 (64-bit version)(RM)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-0-INSYDE.aml, Thu Apr 16 15:19:02 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000390 (912)
 *     Revision         0x01
 *     Checksum         0x63
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "INSYDE  "
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("", "SSDT", 1, "HPQOEM", "INSYDE  ", 0x00001000)
{
    External (_SB_.AWAC, DeviceObj)    // (from opcode)
    External (_SB_.AWAC.WAST, IntObj)    // (from opcode)
    External (BDDD, UnknownObj)    // (from opcode)
    External (GPRW, MethodObj)    // 2 Arguments (from opcode)

    Scope (\_GPE)
    {
        Method (_L72, 0, Serialized)  // _Lxx: Level-Triggered GPE
        {
            If (CondRefOf (\_SB.AWAC))
            {
                Store (One, \_SB.AWAC.WAST)
                Notify (\_SB.AWAC, 0x02)
            }
        }
    }

    Scope (\_SB)
    {
        Device (AWAC)
        {
            Name (_HID, "ACPI000E")  // _HID: Hardware ID
            Name (WAST, Zero)
            Name (WTTR, Zero)
            Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
            {
                Return (GPRW (0x72, 0x04))
            }

            Method (_STA, 0, Serialized)  // _STA: Status
            {
                Switch (BDDD)
                {
                    Case (0x02)
                    {
                        Return (Zero)
                    }
                    Case (0x03)
                    {
                        Return (Zero)
                    }
                    Default
                    {
                        Return (0x0F)
                    }

                }
            }

            OperationRegion (TAOR, SystemMemory, 0xFE000000, 0x10)
            Field (TAOR, AnyAcc, NoLock, Preserve)
            {
                ACWA,   32, 
                DCWA,   32, 
                ACET,   32, 
                DCET,   32
            }

            Method (_GCP, 0, NotSerialized)  // _GCP: Get Capabilities
            {
                Return (0xB7)
            }

            OperationRegion (RTCM, SystemCMOS, Zero, 0x3F)
            Field (RTCM, ByteAcc, Lock, Preserve)
            {
                SEC,    8, 
                Offset (0x02), 
                MIN,    8, 
                Offset (0x04), 
                HOR,    8, 
                Offset (0x07), 
                DAY,    8, 
                MON,    8, 
                YEAR,   8, 
                Offset (0x32), 
                CNTY,   8
            }

            Method (_GRT, 0, NotSerialized)  // _GRT: Get Real Time
            {
                Store (Buffer (0x10){}, Local0)
                CreateWordField (Local0, Zero, Y)
                CreateByteField (Local0, 0x02, M)
                CreateByteField (Local0, 0x03, D)
                CreateByteField (Local0, 0x04, H)
                CreateByteField (Local0, 0x05, MIN1)
                CreateByteField (Local0, 0x06, S)
                CreateByteField (Local0, 0x07, V)
                CreateWordField (Local0, 0x0A, TZ)
                CreateByteField (Local0, 0x0C, DL)
                FromBCD (YEAR, Local5)
                FromBCD (CNTY, Local6)
                Add (Multiply (Local6, 0x64), Local5, Y)
                FromBCD (MON, M)
                FromBCD (DAY, D)
                FromBCD (HOR, H)
                FromBCD (MIN, MIN1)
                FromBCD (SEC, S)
                Store (0x07FF, TZ)
                Store (Zero, DL)
                Store (One, V)
                Return (Local0)
            }

            Method (_SRT, 1, NotSerialized)  // _SRT: Set Real Time
            {
                CreateWordField (Arg0, Zero, Y)
                CreateByteField (Arg0, 0x02, M)
                CreateByteField (Arg0, 0x03, D)
                CreateByteField (Arg0, 0x04, H)
                CreateByteField (Arg0, 0x05, MIN1)
                CreateByteField (Arg0, 0x06, S)
                Divide (Y, 0x64, Local5, Local4)
                ToBCD (Local4, CNTY)
                ToBCD (Local5, YEAR)
                ToBCD (M, MON)
                ToBCD (D, DAY)
                ToBCD (H, HOR)
                ToBCD (MIN1, MIN)
                ToBCD (S, SEC)
                Return (Zero)
            }

            Method (_GWS, 1, Serialized)  // _GWS: Get Wake Status
            {
                Store (Zero, Local0)
                If (LEqual (Arg0, Zero))
                {
                    If (LAnd (LEqual (ACWA, Ones), And (One, WTTR)))
                    {
                        Or (One, Local0, Local0)
                        XOr (One, WTTR, WTTR)
                    }
                }
                ElseIf (LAnd (LEqual (DCWA, Ones), And (0x02, WTTR)))
                {
                    Or (One, Local0, Local0)
                    XOr (0x02, WTTR, WTTR)
                }

                If (WAST)
                {
                    Or (0x02, Local0, Local0)
                    Store (Zero, WAST)
                }

                Return (Local0)
            }

            Method (_CWS, 1, NotSerialized)  // _CWS: Clear Wake Alarm Status
            {
                Return (Zero)
            }

            Method (_STP, 2, NotSerialized)  // _STP: Set Expired Timer Wake Policy
            {
                If (LEqual (One, Arg0))
                {
                    Return (Zero)
                }

                If (LGreater (Arg1, One))
                {
                    Return (One)
                }

                Return (Zero)
            }

            Method (_STV, 2, Serialized)  // _STV: Set Timer Value
            {
                If (LEqual (Arg0, Zero))
                {
                    Store (Arg1, ACWA)
                    Or (One, WTTR, WTTR)
                }
                Else
                {
                    Store (Arg1, DCWA)
                    Or (0x02, WTTR, WTTR)
                }

                Return (Zero)
            }

            Method (_TIP, 1, NotSerialized)  // _TIP: Expired Timer Wake Policy
            {
                If (LEqual (Arg0, Zero))
                {
                    Return (ACET)
                }
                Else
                {
                    Return (DCET)
                }
            }

            Method (_TIV, 1, NotSerialized)  // _TIV: Timer Values
            {
                If (LEqual (Arg0, Zero))
                {
                    Return (ACWA)
                }
                Else
                {
                    Return (DCWA)
                }
            }
        }
    }
}

